REM Start of oliBASIC! Program
REM xylophone
REM Multitouch xylophone
REM by mookiebearapps@2018

samp$="c.mp3"



FN.DEF choosefile$(path$,prompt$,ex$)
 ! pre: path$ is assigned
 ! post: return with path$ assigned
 dloop:

 ! Get the listing from
 ! the path directory
 ! and sort it

 ARRAY.DELETE d1$[]
 FILE.DIR path$, d1$[]
 ARRAY.LENGTH length, d1$[]

 ! Copy the file list
 ! adding the top ",,"
 ! entry


 LIST.CREATE s,dd2
 LIST.ADD dd2 , ".."
 FOR i = 1 TO length
  IF IS_IN("(d)",d1$[I]) | IS_IN(RIGHT$(d1$[I],4),LOWER$(ex$))
   LIST.ADD dd2,d1$[I]
  ENDIF
 NEXT 

 UNDIM d2$[]
 LIST.TOARRAY dd2,d2$[]

 ! Present the list
 ! and get the user's
 ! choice

 DIALOG.SELECT s, d2$[],prompt$



 IF s = 0 THEN FN.RTN ""

 ! If top entry, "..", not
 ! selected then append
 ! the selected directory
 ! name to the path

 IF s>1
  n = IS_IN("(d)", d2$[s])
  IF n = 0
   FN.RTN TRIM$(path$)+TRIM$(d2$[s])
  ENDIF
  dname$ = LEFT$(d2$[s],n-1)
  path$=path$+dname$+"/"
  GOTO dloop
 ENDIF

 ! If s = 1 then must back
 ! one level

 ! if at start path then
 ! back up one level

 IF path$ = ""
  path$ = "../"
  GOTO dloop
 ENDIF

 ! Not at start path
 ! split the path by
 ! the "/" chars

 ARRAY.DELETE p$[]
 SPLIT p$[], path$, "/"
 ARRAY.LENGTH length, p$[]

 ! If the last entry is
 ! ".." then add "../"
 ! to back up one level

 IF p$[length] = ".."
  path$ = path$ + "../"
  GOTO dloop
 ENDIF

 ! Last entry is not ".."
 ! so must delete the
 ! last directory from
 ! the path

 ! If only one entry
 ! then path is back
 ! to the base path

 IF length = 1
  path$ = ""
  GOTO dloop
 ENDIF

 ! Reconstruct path without
 ! the last directory

 path$ = ""
 FOR i = 1 TO length - 1
  path$ = path$ + p$[i] + "/"
 NEXT
 GOTO dloop
FN.END


FN.DEF askyn(p$)
 DIALOG.MESSAGE p$, "", c ,"yes","no"
 IF c=1 THEN FN.RTN 1
 FN.RTN 0
FN.END



FN.DEF hsv2rgb(hue,saturation,value,r,g,b)
 LET r=0:g=0:b=0
 LET chroma=value*saturation
 LET hue1=hue/60

 LET x=chroma*(1-ABS(MOD(hue1, 2)-1))

 IF (hue1 >= 0 & hue1 <= 1)  
  r1=chroma:g1=x:b1=0
 ELSE if (hue1 >= 1 & hue1 <=2) 
  r1=x: g1=chroma:b1=0
 ELSE if (hue1 >= 2 & hue1 <=3) 
  r1=0:g1=chroma:b1=x
 ELSE if (hue1 >= 3 & hue1 <=4)
  r1=0: g1=x:b1=chroma
 ELSE if (hue1 >= 4 & hue1 <=5)
  r1=x:g1=0:b1=chroma
 ELSE if (hue1 >= 5 & hue1 <=6)
  r1=chroma:g1=0:b1=x
 ENDIF
 LET m=value-chroma
 r=r1+m:g=g1+m:b=b1+m
 r=255*r
 g=255*g
 b=255*b
FN.END

FN.DEF rndcolor()
 hsv2rgb(360.*RND(),1.0,0.5+rnd()*0.4,&r,&g,&b)
 GR.COLOR 200,r,g,b
FN.END


FN.DEF DrawStrings(Strings[],StringsGR[],n$[])
 ! draw strings/keys 
 ! pre:n$[] is key label
 ! post:
 ! strings[] is lower y coordinate
 ! stringsgr[] is graphics object
 !
 GR.SCREEN aw,ah
 w=200:h=150
 ARRAY.LENGTH n,n$[]
 GR.TEXT.SIZE h/30
 GR.TEXT.ALIGN 2

 FOR i=1 TO n
  IF !IS_IN("#",n$[i]) THEN n2++
 NEXT


 FOR i=1 TO n
  IF IS_IN("#",n$[i])
   sharp=1
  ELSE 
   sharp=0
   cc++
  ENDIF
  rndcolor()

  IF !sharp
! gr.color 130,255,255,255
   GR.RECT StringsGR[i],(cc-1)*w/n2+w/100,h/2,cc*w/n2-w/100,h
   Strings[i]=(cc-1)*w/n2
   GR.SHOW StringsGR[i]
  ENDIF
 NEXT 

 FOR i=1 TO n
  IF IS_IN("#",n$[i])
   sharp=1
  ELSE 
   sharp=0
   cc++
  ENDIF
 rndcolor()

  s=0.97
  IF sharp
! gr.color 130,10,10,10
   GR.RECT StringsGR[i],s*(i-1)*w/n,0,s*(i)*w/n,h/2
   Strings[i]=s*(i-1)*w/n
   GR.SHOW StringsGR[i]
  ENDIF

 NEXT 

FN.END


! main
TTS.INIT


SOUNDPOOL.OPEN 15


maxt=6
GR.OPEN 255,0,0,0,0,2
GR.SCREEN aw,ah
w=200:h=150
gr.scale aw/w,ah/h

ARRAY.LOAD stringf[],261,277,293,311,330,349,370,392,415,440,466,494,261*2,277*2,293*2,311*2,330*2,349*2


ARRAY.LOAD strings$[], "C","C#","D","D#","E","F","F#","G","G#","A","A#","B","C","C#","D","D#","E","F"


SOUNDPOOL.LOAD cnote,samp$

ARRAY.LENGTH nstrings,stringf[]


DIM Strings[nstrings],StringsGR[nstrings]

DrawStrings(&Strings[],&StringsGR[],strings$[])

GR.RENDER

nbtns=nstrings
DIM btnList[nbtns],f[nbtns]

FOR i=1 TO nstrings
 btnList[i]=Stringsgr[i]:f[i]=stringf[i]/261
NEXT

DIM stream[nBtns],tt[12],state[nBtns],oldstate[nBtns]

GR.COLOR 0,0,0,0
GR.CIRCLE p,0,0,2
GR.SHOW p
GR.SET.STROKE 5
w2=w/2
soff=0
sspan=w
bye=CLOCK()
hold=CLOCK()
! TTS.SPEAK "loaded"

! main loop
DO
 LET nt=0:GR.ARRAY.TOUCH tt[],nt:LET nt=nt*2-1
if !nt then pause 1
! IF nt=-1 & CLOCK()-bye>30000
! D_U.BREAK
! ENDIF 

 ARRAY.FILL state[],0
 FOR i=1 TO nt STEP 2
  LET x=tt[i]*w/aw:LET y=tt[i+1]*h/ah

  GR.MODIFY p,"x",x,"y",y:GR.RENDER

! just check for collisions with buttons and touches
! it's slower but easier...

  FOR j=1 TO nBtns
   IF GR_COLLISION(p,btnlist[j])
    LET state[j]=1
    LET oldkey=key:LET key=j
    F_N.BREAK
   ENDIF
  NEXT
  LET bye=CLOCK()
 NEXT

 IF nt=1 & oldnt=1 & key=oldkey
  IF CLOCK()-hold>3000
   TTS.SPEAK REPLACE$(strings$[key],"#","sharp")
   hold=CLOCK()
  ENDIF
 ENDIF

 IF nt<>1 THEN LET hold=CLOCK()

 FOR j=1 TO nBtns
  IF state[j]&!oldstate[j]
   SOUNDPOOL.STOP stream[j]
   LET l=j/nStrings:LET r=1-l
   SOUNDPOOL.PLAY stream[j], cnote,0.9*l,0.9*r,1.0,0,f[j]
   GR.MODIFY btnlist[j],"alpha",255
  ENDIF
  IF !state[j]
 !    SOUNDPOOL.STOP stream[j]
   GR.MODIFY btnlist[j],"alpha",200
   LET oldstate[j]=0
  ENDIF
 NEXT
 ARRAY.COPY state[],oldstate[]
 IF ++cy=4 THEN GR.RENDER:LET cy=0
 LET oldnt=nt
UNTIL 0

TTS.SPEAK "exiting"
EXIT



ONBACKKEY:


Dialog.message "menu", "choose", c ,"exit","sample","cancel"
if c=1
gr.close 
exit
endif

if c=2

samp$=choosefile$("../../","pick sample wav or mp3",".mp3.wav")

SOUNDPOOL.LOAD cnote,samp$
endif


back.resume


ONBACKGROUND:
IF BACKGROUND() THEN GR.CLOSE:EXIT
BACKGROUND.RESUME
